> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nectarclimate.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update Usage Data

> Update a specific usage data entry by its ID. Updates to the meter and identifiers will also be reflected.



## OpenAPI

````yaml /api-reference/openapi-v2-2.json patch /usage/{msud_id}
openapi: 3.1.0
info:
  title: Nectar API Documentation
  version: 1.0.0 (v1)
  description: >-
    Complete API documentation for v2.2 endpoints to managing companies, sites,
    data, and documents
servers:
  - url: https://external.nectarclimate.com/v2.2
    description: Nectar API Server
security: []
paths:
  /usage/{msud_id}:
    patch:
      tags:
        - Usage Data
      summary: Update Usage Data
      description: >-
        Update a specific usage data entry by its ID. Updates to the meter and
        identifiers will also be reflected.
      operationId: usage_partial_update
      parameters:
        - in: path
          name: msud_id
          schema:
            type: string
            format: uuid
          description: ID of the usage data entry to update.
          required: true
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PatchedMeterSiteUsageDataUpdateRequest'
          application/x-www-form-urlencoded:
            schema:
              $ref: '#/components/schemas/PatchedMeterSiteUsageDataUpdateRequest'
          multipart/form-data:
            schema:
              $ref: '#/components/schemas/PatchedMeterSiteUsageDataUpdateRequest'
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/MeterSiteUsageDataSerializerV2_2'
          description: ''
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: ''
        '403':
          description: 'Forbidden: Access to the usage data is denied.'
        '404':
          description: Usage data not found.
      security:
        - ExternalAuthentication: []
components:
  schemas:
    PatchedMeterSiteUsageDataUpdateRequest:
      type: object
      description: Request body for updating a usage data entry.
      properties:
        startDate:
          type: string
          format: date
          description: Start date for the meter site usage data entry.
        endDate:
          type: string
          format: date
          description: >-
            End date for the meter site usage data entry. If not available or
            not applicable, this is set to the start date by default.
        usage:
          type: number
          format: double
        usageUnits:
          $ref: '#/components/schemas/UsageUnitsEnum'
        isEstimated:
          type: boolean
          description: Indicates if the usage data is estimated by the utility company.
        isImplied:
          type: boolean
          description: >-
            Indicates if the usage data is implied by the tenant usage and the
            raw usage. For  more information on how this differs from
            estimation, see the Nectar methodology.
        tariff:
          type:
            - string
            - 'null'
          description: >-
            [ELECTRICITY, GAS, WATER, DISTRICT] Tariff code or description
            associated with the usage.
        supplierName:
          type:
            - string
            - 'null'
          description: >-
            [ELECTRICITY, GAS] Name of the supplier. Only applies to electricity
            and gas meters.
    MeterSiteUsageDataSerializerV2_2:
      type: object
      description: Usage data entry with document reference and electricity fields.
      properties:
        id:
          type: string
          format: uuid
          description: UUID of the meter site usage data entry.
        created:
          type: string
          format: date-time
          description: Timestamp when the meter site usage data entry was created.
        updated:
          type: string
          format: date-time
          description: Timestamp when the meter site usage data entry was last updated.
        startDate:
          type: string
          format: date
          description: Start date for the meter site usage data entry.
        endDate:
          type: string
          format: date
          description: >-
            End date for the meter site usage data entry. If not available or
            not applicable, this is set to the start date by default.
        usage:
          type: string
          description: >-
            Usage amount extracted from billing data. For solar data, this is
            the kWh produced.
        usageUnits:
          allOf:
            - $ref: '#/components/schemas/UsageUnitsEnum'
          description: |-
            Units for usage, as specified in the document

            * `J` - J
            * `Btu` - Btu
            * `MMBtu` - Mmbtu
            * `kJ` - Kj
            * `MJ` - Mj
            * `GJ` - Gj
            * `TJ` - Tj
            * `thm (EC)` - Therm Ec
            * `thm (US)` - Therm Us
            * `thm (UK)` - Therm Uk
            * `Dth (EC)` - Dth Ec
            * `Dth (US)` - Dth Us
            * `Dth (UK)` - Dth Uk
            * `Cal` - Cal
            * `kCal` - Kcal
            * `MCal` - Mcal
            * `erg` - Erg
            * `kVA` - Kva
            * `Wh` - WH
            * `kWh` - KWH
            * `MWh` - MWH
            * `GWh` - GWH
            * `ton hours` - Ton Hours
            * `W` - W
            * `KW` - Kw
            * `MW` - Mw
            * `GW` - Gw
            * `L` - L
            * `kL` - Kl
            * `ML` - Ml
            * `cubic ft` - Cubic Ft
            * `cubic yd` - Cubic Yd
            * `cubic m` - Cubic M
            * `MMCF` - Mmcf
            * `MCF` - Mcf
            * `HCF` - Hcf
            * `CF` - Cf
            * `CCF` - Ccf
            * `gal (UK)` - Gal Uk
            * `gal (US)` - Gal Us
            * `100 gal (US)` - Hundred Gal Us
            * `100 gal (UK)` - Hundred Gal Uk
            * `kgal (US)` - Kgal Us
            * `kgal (UK)` - Kgal Uk
            * `Mgal (US)` - Million Gal Us
            * `Mgal (UK)` - Million Gal Uk
            * `teu` - Teu
            * `bbl` - Bbl
            * `mbbl` - Mbbl
            * `kg` - Kg
            * `oz t` - Oz T
            * `g` - G
            * `lb` - Lb
            * `mlb` - Mlb
            * `mmlb` - Mmlb
            * `tons (US)` - Tons
            * `sh ton` - Sh Ton
            * `metric ton` - Metric Ton
            * `tonne` - Tonne
            * `long tn` - Long Tn
            * `km` - Km
            * `mi` - Mi
            * `m` - M
            * `cm` - Cm
            * `mm` - Mm
            * `nm` - Nm
            * `yd` - Yd
            * `ft` - Ft
            * `in` - In
        isEstimated:
          type: boolean
          description: Indicates if the usage data is estimated by the utility company.
        isImplied:
          type: boolean
          description: >-
            Indicates if the usage data is implied by the tenant usage and the
            raw usage. For  more information on how this differs from
            estimation, see the Nectar methodology.
        currentReading:
          type:
            - string
            - 'null'
          format: decimal
          pattern: ^-?\d{0,10}(?:\.\d{0,10})?$
          description: Current meter reading.
        previousReading:
          type:
            - string
            - 'null'
          format: decimal
          pattern: ^-?\d{0,10}(?:\.\d{0,10})?$
          description: Previous meter reading.
        multiplier:
          type:
            - string
            - 'null'
          format: decimal
          pattern: ^-?\d{0,10}(?:\.\d{0,10})?$
          description: Multiplier applied to the meter reading.
        multiplierDescription:
          type:
            - string
            - 'null'
          description: >-
            Description of the multiplier applied to the meter reading. E.g.
            conversion factor, pressure adjustment, etc.
        multiplier2:
          type:
            - string
            - 'null'
          format: decimal
          pattern: ^-?\d{0,10}(?:\.\d{0,10})?$
          description: Second multiplier applied to the meter reading.
        multiplier2Description:
          type:
            - string
            - 'null'
          description: >-
            Description of the second multiplier applied to the meter reading.
            E.g. conversion factor, pressure adjustment, etc.
        timeOfUseBreakdown:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/TimeOfUseBreakdown'
          description: >-
            [ELECTRICITY] Array of time-of-use breakdown entries when usage is
            split by TOU periods. Each entry contains timeOfUse category, usage
            amount, units, and optional description/dates. 
        fractionRenewable:
          type:
            - string
            - 'null'
          format: decimal
          pattern: ^-?\d{0,5}(?:\.\d{0,5})?$
          description: >-
            [ELECTRICITY] Fraction of energy sourced from renewable resources (0
            to 1). This field is populated from the utility bill or set by a
            user.
        netMeteringGeneratedKwh:
          type:
            - string
            - 'null'
          format: decimal
          pattern: ^-?\d{0,10}(?:\.\d{0,10})?$
          description: Deprecated. Always returns null.
        netMeteringGridImportKwh:
          type:
            - string
            - 'null'
          format: decimal
          pattern: ^-?\d{0,10}(?:\.\d{0,10})?$
          description: Deprecated. Always returns null.
        netMeteringGridExportKwh:
          type:
            - string
            - 'null'
          format: decimal
          pattern: ^-?\d{0,10}(?:\.\d{0,10})?$
          description: >-
            [ELECTRICITY] Total kWh of electricity exported to the grid, only
            applicable if the meter is not tracking exports.
        exclusion:
          type: boolean
          description: Deprecated. Always returns false.
        tariff:
          type:
            - string
            - 'null'
          description: >-
            [ELECTRICITY, GAS, WATER, DISTRICT] Tariff code or description
            associated with the usage.
        billedDemand:
          type:
            - string
            - 'null'
          format: decimal
          pattern: ^-?\d{0,10}(?:\.\d{0,10})?$
          description: >-
            [ELECTRICITY] Total billed kW, meter level. Only applies to
            electricity meters. If billed demand is not available or allocatable
            across multiple meters, this field is set to 0.
        supplierName:
          type:
            - string
            - 'null'
          description: >-
            [ELECTRICITY, GAS] Name of the supplier. Only applies to electricity
            and gas meters.
        utilityName:
          type:
            - string
            - 'null'
          description: >-
            [ELECTRICITY, GAS] Name of the local delivery utility company. Only
            applies to electricity and gas meters.
        country:
          type:
            - string
            - 'null'
          description: Country associated with the meter site usage data entry.
        serviceAddress:
          type: string
          description: Address of the service location associated with the usage data.
        meter:
          type:
            - string
            - 'null'
          description: >-
            Id of the matching meter associated with the usage data. For
            uploaded documents, field may be empty if no matching meter is
            found.
        site:
          allOf:
            - $ref: '#/components/schemas/SiteSkeletonSerializerV2'
          description: Site matched with the usage data.
        identifiers:
          type: array
          items:
            $ref: '#/components/schemas/IdentifierSkeletonSerializerV2'
          description: Identifiers associated with the meter.
        datasourceType:
          allOf:
            - $ref: '#/components/schemas/DataSourceTypeEnum'
          description: |-
            Type of data source (utility) for the usage data entry.

            * `ELECTRICITY` - Electricity
            * `GAS` - Gas
            * `WATER` - Water
            * `DISTRICT` - District
            * `WASTE` - Waste
            * `FUEL` - Fuel
            * `MISC` - Misc
            * `REFRIGERANT` - Refrigerant
            * `SOLAR` - Solar
            * `TELECOM` - Telecom
        timeOfUse:
          description: >-
            [ELECTRICITY] DEPRECATED — always null. Use timeOfUseBreakdown
            instead.
          oneOf:
            - $ref: '#/components/schemas/TimeOfUseEnum'
            - $ref: '#/components/schemas/NullEnum'
        netMeteringType:
          description: >-
            [ELECTRICITY] Indicates whether the meter is tracking electricity
            imports from the grid, exports to the grid, or onsite generation.


            * `EXPORT` - Export

            * `IMPORT` - Import

            * `GENERATION` - Generation
          oneOf:
            - $ref: '#/components/schemas/NetMeteringTypeEnum'
            - $ref: '#/components/schemas/NullEnum'
        waterType:
          description: |-
            [WATER] Type of water used.

            * `POTABLE_WATER` - Potable Water
            * `WELL_WATER` - Well Water
            * `MUNICIPAL_WATER` - Municipal Water
            * `WASTE_WATER` - Waste Water
          oneOf:
            - $ref: '#/components/schemas/WaterTypeEnum'
            - $ref: '#/components/schemas/NullEnum'
        meterHighLow:
          description: |-
            [WATER] Indicates if the meter type is 'HIGH' or 'LOW'.

            * `HIGH` - High
            * `LOW` - Low
          oneOf:
            - $ref: '#/components/schemas/MeterHighLowEnum'
            - $ref: '#/components/schemas/NullEnum'
        gasType:
          description: |-
            [GAS] Type of gas used.

            * `NATURAL_GAS` - Natural Gas
          oneOf:
            - $ref: '#/components/schemas/GasTypeEnum'
            - $ref: '#/components/schemas/NullEnum'
        fuelType:
          description: |-
            [FUEL] Type of fuel used, with predefined choices.

            * `ANTHRACITE_COAL` - Anthracite Coal
            * `BITUMINOUS_COAL` - Bituminous Coal
            * `SUB_BITUMINOUS_COAL` - Sub Bituminous Coal
            * `LIGNITE_COAL` - Lignite Coal
            * `MIXED_COMMERCIAL_SECTOR` - Mixed Commercial Sector
            * `MIXED_ELECTRIC_POWER_SECTOR` - Mixed Electric Power Sector
            * `MIXED_INDUSTRIAL_COKING` - Mixed Industrial Coking
            * `MIXED_INDUSTRIAL_SECTOR` - Mixed Industrial Sector
            * `COAL_COKE` - Coal Coke
            * `MUNICIPAL_SOLID_WASTE` - Municipal Solid Waste
            * `PETROLEUM_COKE_SOLID` - Petroleum Coke Solid
            * `PLASTICS` - Plastics
            * `TIRES` - Tires
            * `AGRICULTURAL_BYPRODUCTS` - Agricultural Byproducts
            * `PEAT` - Peat
            * `SOLID_BYPRODUCTS` - Solid Byproducts
            * `WOOD_AND_WOOD_RESIDUALS` - Wood And Wood Residuals
            * `NATURAL_GAS` - Natural Gas
            * `BLAST_FURNACE_GAS` - Blast Furnace Gas
            * `COKE_OVEN_GAS` - Coke Oven Gas
            * `FUEL_GAS` - Fuel Gas
            * `PROPANE_GAS` - Propane Gas
            * `LANDFILL_GAS` - Landfill Gas
            * `OTHER_BIOMASS_GASES` - Other Biomass Gases
            * `ASPHALT_AND_ROAD_OIL` - Asphalt And Road Oil
            * `BUTANE` - Butane
            * `BUTYLENE` - Butylene
            * `CRUDE_OIL` - Crude Oil
            * `DISTILLATE_FUEL_OIL_NO_1` - Distillate Fuel Oil No 1
            * `DISTILLATE_FUEL_OIL_NO_2` - Distillate Fuel Oil No 2
            * `DISTILLATE_FUEL_OIL_NO_4` - Distillate Fuel Oil No 4
            * `ETHANE` - Ethane
            * `ETHYLENE` - Ethylene
            * `HEAVY_GAS_OILS` - Heavy Gas Oils
            * `ISOBUTANE` - Isobutane
            * `ISOBUTYLENE` - Isobutylene
            * `KEROSENE` - Kerosene
            * `LIQUEFIED_PETROLEUM_GASES_LPG` - Liquefied Petroleum Gases Lpg
            * `COMPRESSED_NATURAL_GAS_CNG` - Compressed Natural Gas Cng
            * `LUBRICANTS` - Lubricants
            * `MOTOR_GASOLINE` - Motor Gasoline
            * `NAPHTHA_LESS_THAN_401_DEG_F` - Naphtha Less Than 401 Deg F
            * `NATURAL_GASOLINE` - Natural Gasoline
            * `OTHER_OIL_MORE_THAN_401_DEG_F` - Other Oil More Than 401 Deg F
            * `PENTANES_PLUS` - Pentanes Plus
            * `PETROCHEMICAL_FEEDSTOCKS` - Petrochemical Feedstocks
            * `PROPYLENE` - Propylene
            * `RESIDUAL_FUEL_OIL_NO_5` - Residual Fuel Oil No 5
            * `RESIDUAL_FUEL_OIL_NO_6` - Residual Fuel Oil No 6
            * `SPECIAL_NAPHTHA` - Special Naphtha
            * `UNFINISHED_OILS` - Unfinished Oils
            * `USED_OIL` - Used Oil
            * `BIODIESEL_100_PERCENT` - Biodiesel 100 Percent
            * `BIODIESEL_BLEND` - Biodiesel Blend
            * `ETHANOL_BLENDED_GASOLINE` - Ethanol Blended Gasoline
            * `ETHANOL_100_PERCENT` - Ethanol 100 Percent
            * `RENDERED_ANIMAL_FAT` - Rendered Animal Fat
            * `VEGETABLE_OIL` - Vegetable Oil
            * `NORTH_AMERICAN_SOFTWOOD` - North American Softwood
            * `NORTH_AMERICAN_HARDWOOD` - North American Hardwood
            * `BAGASSE` - Bagasse
            * `BAMBOO` - Bamboo
            * `STRAW` - Straw
          oneOf:
            - $ref: '#/components/schemas/FuelTypeEnum'
            - $ref: '#/components/schemas/NullEnum'
        districtType:
          description: |-
            [DISTRICT] Type of district used, either HEATING or COOLING.

            * `HEATING` - Heating
            * `COOLING` - Cooling
          oneOf:
            - $ref: '#/components/schemas/DistrictTypeEnum'
            - $ref: '#/components/schemas/NullEnum'
        districtMediumType:
          description: >-
            [DISTRICT] Type of heating or cooling medium used, e.g. STEAM,
            HOT_WATER, etc.


            * `HOT_WATER` - Hot Water

            * `STEAM` - Steam

            * `HOT_OIL` - Hot Oil

            * `CHILLED_WATER` - Chilled Water
          oneOf:
            - $ref: '#/components/schemas/DistrictMediumTypeEnum'
            - $ref: '#/components/schemas/NullEnum'
        wasteDescription:
          type: string
          description: >-
            [WASTE] Description of the waste line item. E.g. OCC, Plastic
            bottles, etc.
        wasteType:
          type: string
          description: >-
            [WASTE] Type of waste, e.g. OCC, Plastic bottles, etc. The waste
            type config can be configured on the Nectar platform.
        wasteStream:
          type: string
          description: >-
            [WASTE] Stream of waste, e.g. OCC, Plastic bottles, etc. The waste
            stream config can be configured on the Nectar platform.
        refrigerantType:
          description: |-
            [REFRIGERANT] Type of refrigerant used.

            * `R11` - R11
            * `R12` - R12
            * `R22` - R22
            * `R123` - R123
            * `R124` - R124
            * `R134A` - R134A
            * `R401A` - R401A
            * `R401B` - R401B
            * `R402A` - R402A
            * `R402B` - R402B
            * `R403A` - R403A
            * `R403B` - R403B
            * `R404A` - R404A
            * `R405A` - R405A
            * `R406A` - R406A
            * `R407A` - R407A
            * `R407B` - R407B
            * `R407C` - R407C
            * `R407D` - R407D
            * `R407F` - R407F
            * `R408A` - R408A
            * `R409A` - R409A
            * `R409B` - R409B
            * `R410A` - R410A
            * `R410B` - R410B
            * `R411A` - R411A
            * `R411B` - R411B
            * `R412A` - R412A
            * `R413A` - R413A
            * `R413B` - R413B
            * `R414A` - R414A
            * `R414B` - R414B
            * `R415A` - R415A
            * `R415B` - R415B
            * `R416A` - R416A
            * `R417A` - R417A
            * `R417B` - R417B
            * `R417C` - R417C
            * `R418A` - R418A
            * `R419A` - R419A
            * `R419B` - R419B
            * `R420A` - R420A
            * `R420B` - R420B
            * `R421A` - R421A
            * `R421B` - R421B
            * `R421C` - R421C
            * `R422A` - R422A
            * `R422B` - R422B
            * `R422C` - R422C
            * `R422D` - R422D
            * `R422E` - R422E
            * `R423A` - R423A
            * `R423B` - R423B
            * `R424A` - R424A
            * `R424B` - R424B
            * `R425A` - R425A
            * `R426A` - R426A
            * `R426B` - R426B
            * `R426C` - R426C
            * `R427A` - R427A
            * `R427B` - R427B
            * `R427C` - R427C
            * `R428A` - R428A
            * `R428B` - R428B
            * `R429A` - R429A
            * `R429B` - R429B
            * `R430A` - R430A
            * `R430B` - R430B
            * `R431A` - R431A
            * `R431B` - R431B
            * `R432A` - R432A
            * `R432B` - R432B
            * `R433A` - R433A
            * `R433B` - R433B
            * `R433C` - R433C
            * `R433D` - R433D
            * `R434A` - R434A
            * `R434B` - R434B
            * `R435A` - R435A
            * `R435B` - R435B
            * `R436A` - R436A
            * `R436B` - R436B
            * `R437A` - R437A
            * `R437B` - R437B
            * `R438A` - R438A
            * `R438B` - R438B
            * `R444B` - R444B
            * `R445A` - R445A
            * `R447A` - R447A
            * `R448A` - R448A
            * `R448B` - R448B
            * `R449A` - R449A
            * `R449B` - R449B
            * `R450A` - R450A
            * `R450B` - R450B
            * `R451A` - R451A
            * `R451B` - R451B
            * `R452A` - R452A
            * `R452B` - R452B
            * `R453A` - R453A
            * `R454A` - R454A
            * `R454B` - R454B
            * `R454C` - R454C
            * `R455A` - R455A
            * `R456A` - R456A
            * `R459A` - R459A
            * `R460A` - R460A
            * `R461A` - R461A
            * `R462A` - R462A
            * `R463A` - R463A
            * `R464A` - R464A
            * `R465A` - R465A
            * `R115` - R115
            * `R116` - R116
            * `R12B1` - R12B1
            * `R13` - R13
            * `R13B1` - R13B1
            * `R13I1` - R13I1
            * `R14` - R14
            * `R14e` - R14E
            * `R21` - R21
            * `R23` - R23
            * `R30` - R30
            * `R31` - R31
            * `R40` - R40
            * `R41` - R41
            * `R50` - R50
            * `R113` - R113
            * `R114` - R114
            * `R125` - R125
            * `R141B` - R141B
            * `R142B` - R142B
            * `R143A` - R143A
            * `R152A` - R152A
            * `R170` - R170
            * `R218` - R218
            * `R290` - R290
            * `R318` - R318
            * `R600` - R600
            * `R600A` - R600A
            * `R717` - R717
            * `R744` - R744
            * `R508B` - R508B
            * `R1270` - R1270
            * `R32` - R32
            * `R161` - R161
            * `R227EA` - R227Ea
            * `R236CB` - R236Cb
            * `R236EA` - R236Ea
            * `R236FA` - R236Fa
            * `R245CA` - R245Ca
            * `R245FA` - R245Fa
            * `R414C` - R414C
            * `R415C` - R415C
            * `R416B` - R416B
            * `R123A` - R123A
            * `R123B` - R123B
            * `R365MFC` - R365Mfc
            * `R4310` - R4310
            * `R127C` - R127C
            * `R12A` - R12A
            * `R22A` - R22A
            * `R502A` - R502A
            * `R601A` - R601A
          oneOf:
            - $ref: '#/components/schemas/RefrigerantTypeEnum'
            - $ref: '#/components/schemas/NullEnum'
        additionalFields:
          type: object
          additionalProperties: {}
          description: >-
            Additional fields for the usage data. For information on adding
            custom fields to the Nectar schema get in touch with our team.
        meterIsTracked:
          type: boolean
          description: Whether the meter is tracked.
        meterAddress:
          type:
            - string
            - 'null'
          description: Address of the meter.
        apparentUsage:
          type:
            - string
            - 'null'
          format: decimal
          pattern: ^-?\d{0,10}(?:\.\d{0,10})?$
          description: >-
            [ELECTRICITY] Apparent usage amount for the meter site usage data
            entry.
        apparentUsageUnits:
          description: |-
            [ELECTRICITY] Units for the apparent usage amount.

            * `kVAh` - Kvah
            * `MVAh` - Mvah
            * `GVAh` - Gvah
          oneOf:
            - $ref: '#/components/schemas/ApparentUsageUnitsEnum'
            - $ref: '#/components/schemas/BlankEnum'
            - $ref: '#/components/schemas/NullEnum'
        reactiveUsage:
          type:
            - string
            - 'null'
          format: decimal
          pattern: ^-?\d{0,10}(?:\.\d{0,10})?$
          description: >-
            [ELECTRICITY] Reactive usage amount for the meter site usage data
            entry.
        reactiveUsageUnits:
          description: |-
            [ELECTRICITY] Units for the reactive usage amount.

            * `kVArh` - Kvarh
            * `MVArh` - Mvarh
            * `GVArh` - Gvarh
          oneOf:
            - $ref: '#/components/schemas/ReactiveUsageUnitsEnum'
            - $ref: '#/components/schemas/BlankEnum'
            - $ref: '#/components/schemas/NullEnum'
        powerFactor:
          type:
            - string
            - 'null'
          format: decimal
          pattern: ^-?\d{0,1}(?:\.\d{0,19})?$
          description: >-
            [ELECTRICITY] Ratio of apparent and real usage. Must be between 0.0
            and 1.0.
        electricityType:
          description: |-
            [ELECTRICITY] Type of electricity used.

            * `USAGE` - Usage
            * `DEMAND` - Demand
          oneOf:
            - $ref: '#/components/schemas/ElectricityTypeEnum'
            - $ref: '#/components/schemas/NullEnum'
        document:
          allOf:
            - $ref: '#/components/schemas/DocumentSkeletonSerializerV2'
          description: Document associated with the usage data.
      required:
        - additionalFields
        - created
        - datasourceType
        - districtMediumType
        - districtType
        - document
        - electricityType
        - endDate
        - exclusion
        - fuelType
        - gasType
        - id
        - identifiers
        - meter
        - meterAddress
        - meterHighLow
        - meterIsTracked
        - netMeteringGeneratedKwh
        - netMeteringGridImportKwh
        - netMeteringType
        - refrigerantType
        - serviceAddress
        - site
        - startDate
        - timeOfUse
        - timeOfUseBreakdown
        - usage
        - usageUnits
        - wasteDescription
        - wasteStream
        - wasteType
        - waterType
    ErrorResponse:
      type: object
      description: Serializer for error responses.
      properties:
        detail:
          type: string
        error:
          type: string
    UsageUnitsEnum:
      enum:
        - J
        - Btu
        - MMBtu
        - kJ
        - MJ
        - GJ
        - TJ
        - thm (EC)
        - thm (US)
        - thm (UK)
        - Dth (EC)
        - Dth (US)
        - Dth (UK)
        - Cal
        - kCal
        - MCal
        - erg
        - kVA
        - Wh
        - kWh
        - MWh
        - GWh
        - ton hours
        - W
        - KW
        - MW
        - GW
        - L
        - kL
        - ML
        - cubic ft
        - cubic yd
        - cubic m
        - MMCF
        - MCF
        - HCF
        - CF
        - CCF
        - gal (UK)
        - gal (US)
        - 100 gal (US)
        - 100 gal (UK)
        - kgal (US)
        - kgal (UK)
        - Mgal (US)
        - Mgal (UK)
        - teu
        - bbl
        - mbbl
        - kg
        - oz t
        - g
        - lb
        - mlb
        - mmlb
        - tons (US)
        - sh ton
        - metric ton
        - tonne
        - long tn
        - km
        - mi
        - m
        - cm
        - mm
        - nm
        - yd
        - ft
        - in
      type: string
      description: |-
        * `J` - J
        * `Btu` - Btu
        * `MMBtu` - Mmbtu
        * `kJ` - Kj
        * `MJ` - Mj
        * `GJ` - Gj
        * `TJ` - Tj
        * `thm (EC)` - Therm Ec
        * `thm (US)` - Therm Us
        * `thm (UK)` - Therm Uk
        * `Dth (EC)` - Dth Ec
        * `Dth (US)` - Dth Us
        * `Dth (UK)` - Dth Uk
        * `Cal` - Cal
        * `kCal` - Kcal
        * `MCal` - Mcal
        * `erg` - Erg
        * `kVA` - Kva
        * `Wh` - WH
        * `kWh` - KWH
        * `MWh` - MWH
        * `GWh` - GWH
        * `ton hours` - Ton Hours
        * `W` - W
        * `KW` - Kw
        * `MW` - Mw
        * `GW` - Gw
        * `L` - L
        * `kL` - Kl
        * `ML` - Ml
        * `cubic ft` - Cubic Ft
        * `cubic yd` - Cubic Yd
        * `cubic m` - Cubic M
        * `MMCF` - Mmcf
        * `MCF` - Mcf
        * `HCF` - Hcf
        * `CF` - Cf
        * `CCF` - Ccf
        * `gal (UK)` - Gal Uk
        * `gal (US)` - Gal Us
        * `100 gal (US)` - Hundred Gal Us
        * `100 gal (UK)` - Hundred Gal Uk
        * `kgal (US)` - Kgal Us
        * `kgal (UK)` - Kgal Uk
        * `Mgal (US)` - Million Gal Us
        * `Mgal (UK)` - Million Gal Uk
        * `teu` - Teu
        * `bbl` - Bbl
        * `mbbl` - Mbbl
        * `kg` - Kg
        * `oz t` - Oz T
        * `g` - G
        * `lb` - Lb
        * `mlb` - Mlb
        * `mmlb` - Mmlb
        * `tons (US)` - Tons
        * `sh ton` - Sh Ton
        * `metric ton` - Metric Ton
        * `tonne` - Tonne
        * `long tn` - Long Tn
        * `km` - Km
        * `mi` - Mi
        * `m` - M
        * `cm` - Cm
        * `mm` - Mm
        * `nm` - Nm
        * `yd` - Yd
        * `ft` - Ft
        * `in` - In
    TimeOfUseBreakdown:
      type: object
      description: Serializer for time-of-use breakdown entries.
      properties:
        timeOfUse:
          allOf:
            - $ref: '#/components/schemas/TimeOfUseEnum'
          description: |-
            Time of use category (e.g., PEAK, OFF_PEAK, SHOULDER_MIDPEAK).

            * `PEAK` - Peak
            * `OFF_PEAK` - Off Peak
            * `SHOULDER_MIDPEAK` - Shoulder Midpeak
            * `NIGHT_TIME` - Night Time
            * `DAY_TIME` - Day Time
            * `SUPER_OFF_PEAK` - Super Off Peak
            * `CRITICAL_PEAK` - Critical Peak
            * `WEEKDAY` - Weekday
            * `WEEKEND` - Weekend
            * `OTHER` - Other
        description:
          type:
            - string
            - 'null'
          description: >-
            Optional description or label from the bill for this time of use
            period.
        usage:
          type: string
          format: decimal
          pattern: ^-?\d{0,10}(?:\.\d{0,10})?$
          description: Usage amount for this time of use period.
        usageUnits:
          allOf:
            - $ref: '#/components/schemas/ElectricityUsageUnitsEnum'
          description: |-
            Units for the usage amount (must match parent usage data's units).

            * `Wh` - WH
            * `kWh` - KWH
            * `MWh` - MWH
            * `GWh` - GWH
        startDate:
          type:
            - string
            - 'null'
          format: date
          description: >-
            Start date for this time of use period if different from parent
            usage data.
        endDate:
          type:
            - string
            - 'null'
          format: date
          description: >-
            End date for this time of use period if different from parent usage
            data.
      required:
        - timeOfUse
        - usage
        - usageUnits
    SiteSkeletonSerializerV2:
      type: object
      description: Skeleton serializer for externally available fields of a Site object.
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier for the site.
        externalId:
          type:
            - string
            - 'null'
          description: >-
            ID of the site on external platforms used during exports. Used to
            associate site in Nectar with site within your database.
        name:
          type: string
          description: Name of the site.
          maxLength: 255
        address:
          type: string
          description: Address of the site.
          maxLength: 255
        path:
          type: array
          items:
            type: string
            maxLength: 100
          description: >-
            List of location tags in increasing specificity used to filter
            sites. Filters must be entered from more general to more specific.
            E.g. ['US', 'CA', 'ON']
          maxItems: 10
        occupancyPercent:
          type:
            - string
            - 'null'
          format: decimal
          pattern: ^-?\d{0,3}(?:\.\d{0,4})?$
          description: >-
            Occupancy percent, must be a number from 0 to 100. Usage for the
            site will be multiplied by this value for specified connections.
        dataCollectionStopDate:
          type:
            - string
            - 'null'
          format: date
          description: >-
            Date when data collection for this site was stopped. A non-null
            value indicates the site has been soft-deleted/archived.
      required:
        - dataCollectionStopDate
        - id
        - name
    IdentifierSkeletonSerializerV2:
      type: object
      description: Serializer for all fields of Identifier, used in usage endpoints.
      properties:
        name:
          type:
            - string
            - 'null'
          description: Name of the identifier.
        rawName:
          type: string
          description: Raw name of the identifier as found in the document.
          maxLength: 200
        value:
          type: string
          description: Value of the identifier.
          maxLength: 200
      required:
        - rawName
        - value
    DataSourceTypeEnum:
      enum:
        - ELECTRICITY
        - GAS
        - WATER
        - DISTRICT
        - WASTE
        - FUEL
        - MISC
        - REFRIGERANT
        - SOLAR
        - TELECOM
      type: string
      description: |-
        * `ELECTRICITY` - Electricity
        * `GAS` - Gas
        * `WATER` - Water
        * `DISTRICT` - District
        * `WASTE` - Waste
        * `FUEL` - Fuel
        * `MISC` - Misc
        * `REFRIGERANT` - Refrigerant
        * `SOLAR` - Solar
        * `TELECOM` - Telecom
    TimeOfUseEnum:
      enum:
        - PEAK
        - OFF_PEAK
        - SHOULDER_MIDPEAK
        - NIGHT_TIME
        - DAY_TIME
        - SUPER_OFF_PEAK
        - CRITICAL_PEAK
        - WEEKDAY
        - WEEKEND
        - OTHER
      type: string
    NullEnum:
      type: 'null'
    NetMeteringTypeEnum:
      enum:
        - EXPORT
        - IMPORT
        - GENERATION
      type: string
      description: |-
        * `EXPORT` - Export
        * `IMPORT` - Import
        * `GENERATION` - Generation
    WaterTypeEnum:
      enum:
        - POTABLE_WATER
        - WELL_WATER
        - MUNICIPAL_WATER
        - WASTE_WATER
      type: string
      description: |-
        * `POTABLE_WATER` - Potable Water
        * `WELL_WATER` - Well Water
        * `MUNICIPAL_WATER` - Municipal Water
        * `WASTE_WATER` - Waste Water
    MeterHighLowEnum:
      enum:
        - HIGH
        - LOW
      type: string
      description: |-
        * `HIGH` - High
        * `LOW` - Low
    GasTypeEnum:
      enum:
        - NATURAL_GAS
      type: string
      description: '* `NATURAL_GAS` - Natural Gas'
    FuelTypeEnum:
      enum:
        - ANTHRACITE_COAL
        - BITUMINOUS_COAL
        - SUB_BITUMINOUS_COAL
        - LIGNITE_COAL
        - MIXED_COMMERCIAL_SECTOR
        - MIXED_ELECTRIC_POWER_SECTOR
        - MIXED_INDUSTRIAL_COKING
        - MIXED_INDUSTRIAL_SECTOR
        - COAL_COKE
        - MUNICIPAL_SOLID_WASTE
        - PETROLEUM_COKE_SOLID
        - PLASTICS
        - TIRES
        - AGRICULTURAL_BYPRODUCTS
        - PEAT
        - SOLID_BYPRODUCTS
        - WOOD_AND_WOOD_RESIDUALS
        - NATURAL_GAS
        - BLAST_FURNACE_GAS
        - COKE_OVEN_GAS
        - FUEL_GAS
        - PROPANE_GAS
        - LANDFILL_GAS
        - OTHER_BIOMASS_GASES
        - ASPHALT_AND_ROAD_OIL
        - BUTANE
        - BUTYLENE
        - CRUDE_OIL
        - DISTILLATE_FUEL_OIL_NO_1
        - DISTILLATE_FUEL_OIL_NO_2
        - DISTILLATE_FUEL_OIL_NO_4
        - ETHANE
        - ETHYLENE
        - HEAVY_GAS_OILS
        - ISOBUTANE
        - ISOBUTYLENE
        - KEROSENE
        - LIQUEFIED_PETROLEUM_GASES_LPG
        - COMPRESSED_NATURAL_GAS_CNG
        - LUBRICANTS
        - MOTOR_GASOLINE
        - NAPHTHA_LESS_THAN_401_DEG_F
        - NATURAL_GASOLINE
        - OTHER_OIL_MORE_THAN_401_DEG_F
        - PENTANES_PLUS
        - PETROCHEMICAL_FEEDSTOCKS
        - PROPYLENE
        - RESIDUAL_FUEL_OIL_NO_5
        - RESIDUAL_FUEL_OIL_NO_6
        - SPECIAL_NAPHTHA
        - UNFINISHED_OILS
        - USED_OIL
        - BIODIESEL_100_PERCENT
        - BIODIESEL_BLEND
        - ETHANOL_BLENDED_GASOLINE
        - ETHANOL_100_PERCENT
        - RENDERED_ANIMAL_FAT
        - VEGETABLE_OIL
        - NORTH_AMERICAN_SOFTWOOD
        - NORTH_AMERICAN_HARDWOOD
        - BAGASSE
        - BAMBOO
        - STRAW
      type: string
      description: |-
        * `ANTHRACITE_COAL` - Anthracite Coal
        * `BITUMINOUS_COAL` - Bituminous Coal
        * `SUB_BITUMINOUS_COAL` - Sub Bituminous Coal
        * `LIGNITE_COAL` - Lignite Coal
        * `MIXED_COMMERCIAL_SECTOR` - Mixed Commercial Sector
        * `MIXED_ELECTRIC_POWER_SECTOR` - Mixed Electric Power Sector
        * `MIXED_INDUSTRIAL_COKING` - Mixed Industrial Coking
        * `MIXED_INDUSTRIAL_SECTOR` - Mixed Industrial Sector
        * `COAL_COKE` - Coal Coke
        * `MUNICIPAL_SOLID_WASTE` - Municipal Solid Waste
        * `PETROLEUM_COKE_SOLID` - Petroleum Coke Solid
        * `PLASTICS` - Plastics
        * `TIRES` - Tires
        * `AGRICULTURAL_BYPRODUCTS` - Agricultural Byproducts
        * `PEAT` - Peat
        * `SOLID_BYPRODUCTS` - Solid Byproducts
        * `WOOD_AND_WOOD_RESIDUALS` - Wood And Wood Residuals
        * `NATURAL_GAS` - Natural Gas
        * `BLAST_FURNACE_GAS` - Blast Furnace Gas
        * `COKE_OVEN_GAS` - Coke Oven Gas
        * `FUEL_GAS` - Fuel Gas
        * `PROPANE_GAS` - Propane Gas
        * `LANDFILL_GAS` - Landfill Gas
        * `OTHER_BIOMASS_GASES` - Other Biomass Gases
        * `ASPHALT_AND_ROAD_OIL` - Asphalt And Road Oil
        * `BUTANE` - Butane
        * `BUTYLENE` - Butylene
        * `CRUDE_OIL` - Crude Oil
        * `DISTILLATE_FUEL_OIL_NO_1` - Distillate Fuel Oil No 1
        * `DISTILLATE_FUEL_OIL_NO_2` - Distillate Fuel Oil No 2
        * `DISTILLATE_FUEL_OIL_NO_4` - Distillate Fuel Oil No 4
        * `ETHANE` - Ethane
        * `ETHYLENE` - Ethylene
        * `HEAVY_GAS_OILS` - Heavy Gas Oils
        * `ISOBUTANE` - Isobutane
        * `ISOBUTYLENE` - Isobutylene
        * `KEROSENE` - Kerosene
        * `LIQUEFIED_PETROLEUM_GASES_LPG` - Liquefied Petroleum Gases Lpg
        * `COMPRESSED_NATURAL_GAS_CNG` - Compressed Natural Gas Cng
        * `LUBRICANTS` - Lubricants
        * `MOTOR_GASOLINE` - Motor Gasoline
        * `NAPHTHA_LESS_THAN_401_DEG_F` - Naphtha Less Than 401 Deg F
        * `NATURAL_GASOLINE` - Natural Gasoline
        * `OTHER_OIL_MORE_THAN_401_DEG_F` - Other Oil More Than 401 Deg F
        * `PENTANES_PLUS` - Pentanes Plus
        * `PETROCHEMICAL_FEEDSTOCKS` - Petrochemical Feedstocks
        * `PROPYLENE` - Propylene
        * `RESIDUAL_FUEL_OIL_NO_5` - Residual Fuel Oil No 5
        * `RESIDUAL_FUEL_OIL_NO_6` - Residual Fuel Oil No 6
        * `SPECIAL_NAPHTHA` - Special Naphtha
        * `UNFINISHED_OILS` - Unfinished Oils
        * `USED_OIL` - Used Oil
        * `BIODIESEL_100_PERCENT` - Biodiesel 100 Percent
        * `BIODIESEL_BLEND` - Biodiesel Blend
        * `ETHANOL_BLENDED_GASOLINE` - Ethanol Blended Gasoline
        * `ETHANOL_100_PERCENT` - Ethanol 100 Percent
        * `RENDERED_ANIMAL_FAT` - Rendered Animal Fat
        * `VEGETABLE_OIL` - Vegetable Oil
        * `NORTH_AMERICAN_SOFTWOOD` - North American Softwood
        * `NORTH_AMERICAN_HARDWOOD` - North American Hardwood
        * `BAGASSE` - Bagasse
        * `BAMBOO` - Bamboo
        * `STRAW` - Straw
    DistrictTypeEnum:
      enum:
        - HEATING
        - COOLING
      type: string
      description: |-
        * `HEATING` - Heating
        * `COOLING` - Cooling
    DistrictMediumTypeEnum:
      enum:
        - HOT_WATER
        - STEAM
        - HOT_OIL
        - CHILLED_WATER
      type: string
      description: |-
        * `HOT_WATER` - Hot Water
        * `STEAM` - Steam
        * `HOT_OIL` - Hot Oil
        * `CHILLED_WATER` - Chilled Water
    RefrigerantTypeEnum:
      enum:
        - R11
        - R12
        - R22
        - R123
        - R124
        - R134A
        - R401A
        - R401B
        - R402A
        - R402B
        - R403A
        - R403B
        - R404A
        - R405A
        - R406A
        - R407A
        - R407B
        - R407C
        - R407D
        - R407F
        - R408A
        - R409A
        - R409B
        - R410A
        - R410B
        - R411A
        - R411B
        - R412A
        - R413A
        - R413B
        - R414A
        - R414B
        - R415A
        - R415B
        - R416A
        - R417A
        - R417B
        - R417C
        - R418A
        - R419A
        - R419B
        - R420A
        - R420B
        - R421A
        - R421B
        - R421C
        - R422A
        - R422B
        - R422C
        - R422D
        - R422E
        - R423A
        - R423B
        - R424A
        - R424B
        - R425A
        - R426A
        - R426B
        - R426C
        - R427A
        - R427B
        - R427C
        - R428A
        - R428B
        - R429A
        - R429B
        - R430A
        - R430B
        - R431A
        - R431B
        - R432A
        - R432B
        - R433A
        - R433B
        - R433C
        - R433D
        - R434A
        - R434B
        - R435A
        - R435B
        - R436A
        - R436B
        - R437A
        - R437B
        - R438A
        - R438B
        - R444B
        - R445A
        - R447A
        - R448A
        - R448B
        - R449A
        - R449B
        - R450A
        - R450B
        - R451A
        - R451B
        - R452A
        - R452B
        - R453A
        - R454A
        - R454B
        - R454C
        - R455A
        - R456A
        - R459A
        - R460A
        - R461A
        - R462A
        - R463A
        - R464A
        - R465A
        - R115
        - R116
        - R12B1
        - R13
        - R13B1
        - R13I1
        - R14
        - R14e
        - R21
        - R23
        - R30
        - R31
        - R40
        - R41
        - R50
        - R113
        - R114
        - R125
        - R141B
        - R142B
        - R143A
        - R152A
        - R170
        - R218
        - R290
        - R318
        - R600
        - R600A
        - R717
        - R744
        - R508B
        - R1270
        - R32
        - R161
        - R227EA
        - R236CB
        - R236EA
        - R236FA
        - R245CA
        - R245FA
        - R414C
        - R415C
        - R416B
        - R123A
        - R123B
        - R365MFC
        - R4310
        - R127C
        - R12A
        - R22A
        - R502A
        - R601A
      type: string
      description: |-
        * `R11` - R11
        * `R12` - R12
        * `R22` - R22
        * `R123` - R123
        * `R124` - R124
        * `R134A` - R134A
        * `R401A` - R401A
        * `R401B` - R401B
        * `R402A` - R402A
        * `R402B` - R402B
        * `R403A` - R403A
        * `R403B` - R403B
        * `R404A` - R404A
        * `R405A` - R405A
        * `R406A` - R406A
        * `R407A` - R407A
        * `R407B` - R407B
        * `R407C` - R407C
        * `R407D` - R407D
        * `R407F` - R407F
        * `R408A` - R408A
        * `R409A` - R409A
        * `R409B` - R409B
        * `R410A` - R410A
        * `R410B` - R410B
        * `R411A` - R411A
        * `R411B` - R411B
        * `R412A` - R412A
        * `R413A` - R413A
        * `R413B` - R413B
        * `R414A` - R414A
        * `R414B` - R414B
        * `R415A` - R415A
        * `R415B` - R415B
        * `R416A` - R416A
        * `R417A` - R417A
        * `R417B` - R417B
        * `R417C` - R417C
        * `R418A` - R418A
        * `R419A` - R419A
        * `R419B` - R419B
        * `R420A` - R420A
        * `R420B` - R420B
        * `R421A` - R421A
        * `R421B` - R421B
        * `R421C` - R421C
        * `R422A` - R422A
        * `R422B` - R422B
        * `R422C` - R422C
        * `R422D` - R422D
        * `R422E` - R422E
        * `R423A` - R423A
        * `R423B` - R423B
        * `R424A` - R424A
        * `R424B` - R424B
        * `R425A` - R425A
        * `R426A` - R426A
        * `R426B` - R426B
        * `R426C` - R426C
        * `R427A` - R427A
        * `R427B` - R427B
        * `R427C` - R427C
        * `R428A` - R428A
        * `R428B` - R428B
        * `R429A` - R429A
        * `R429B` - R429B
        * `R430A` - R430A
        * `R430B` - R430B
        * `R431A` - R431A
        * `R431B` - R431B
        * `R432A` - R432A
        * `R432B` - R432B
        * `R433A` - R433A
        * `R433B` - R433B
        * `R433C` - R433C
        * `R433D` - R433D
        * `R434A` - R434A
        * `R434B` - R434B
        * `R435A` - R435A
        * `R435B` - R435B
        * `R436A` - R436A
        * `R436B` - R436B
        * `R437A` - R437A
        * `R437B` - R437B
        * `R438A` - R438A
        * `R438B` - R438B
        * `R444B` - R444B
        * `R445A` - R445A
        * `R447A` - R447A
        * `R448A` - R448A
        * `R448B` - R448B
        * `R449A` - R449A
        * `R449B` - R449B
        * `R450A` - R450A
        * `R450B` - R450B
        * `R451A` - R451A
        * `R451B` - R451B
        * `R452A` - R452A
        * `R452B` - R452B
        * `R453A` - R453A
        * `R454A` - R454A
        * `R454B` - R454B
        * `R454C` - R454C
        * `R455A` - R455A
        * `R456A` - R456A
        * `R459A` - R459A
        * `R460A` - R460A
        * `R461A` - R461A
        * `R462A` - R462A
        * `R463A` - R463A
        * `R464A` - R464A
        * `R465A` - R465A
        * `R115` - R115
        * `R116` - R116
        * `R12B1` - R12B1
        * `R13` - R13
        * `R13B1` - R13B1
        * `R13I1` - R13I1
        * `R14` - R14
        * `R14e` - R14E
        * `R21` - R21
        * `R23` - R23
        * `R30` - R30
        * `R31` - R31
        * `R40` - R40
        * `R41` - R41
        * `R50` - R50
        * `R113` - R113
        * `R114` - R114
        * `R125` - R125
        * `R141B` - R141B
        * `R142B` - R142B
        * `R143A` - R143A
        * `R152A` - R152A
        * `R170` - R170
        * `R218` - R218
        * `R290` - R290
        * `R318` - R318
        * `R600` - R600
        * `R600A` - R600A
        * `R717` - R717
        * `R744` - R744
        * `R508B` - R508B
        * `R1270` - R1270
        * `R32` - R32
        * `R161` - R161
        * `R227EA` - R227Ea
        * `R236CB` - R236Cb
        * `R236EA` - R236Ea
        * `R236FA` - R236Fa
        * `R245CA` - R245Ca
        * `R245FA` - R245Fa
        * `R414C` - R414C
        * `R415C` - R415C
        * `R416B` - R416B
        * `R123A` - R123A
        * `R123B` - R123B
        * `R365MFC` - R365Mfc
        * `R4310` - R4310
        * `R127C` - R127C
        * `R12A` - R12A
        * `R22A` - R22A
        * `R502A` - R502A
        * `R601A` - R601A
    ApparentUsageUnitsEnum:
      enum:
        - kVAh
        - MVAh
        - GVAh
      type: string
      description: |-
        * `kVAh` - Kvah
        * `MVAh` - Mvah
        * `GVAh` - Gvah
    BlankEnum:
      enum:
        - ''
    ReactiveUsageUnitsEnum:
      enum:
        - kVArh
        - MVArh
        - GVArh
      type: string
      description: |-
        * `kVArh` - Kvarh
        * `MVArh` - Mvarh
        * `GVArh` - Gvarh
    ElectricityTypeEnum:
      enum:
        - USAGE
        - DEMAND
      type: string
      description: |-
        * `USAGE` - Usage
        * `DEMAND` - Demand
    DocumentSkeletonSerializerV2:
      type: object
      description: >-
        Skeleton serializer for externally available fields of a Document
        object.
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier for the document.
        created:
          type: string
          format: date-time
          description: Timestamp when the document was created.
        updated:
          type: string
          format: date-time
          description: Timestamp when the document was last updated.
        auditTrailUrl:
          type: string
          description: >-
            URL to view the audit trail of the document on Nectar's platform.
            Includes side-by-side view of Nectar's parsed data vs. the original
            raw document and the edit history.
        url:
          type:
            - string
            - 'null'
          description: >-
            Presigned URL for accessing the document stored in S3. URL expires
            in 1 day.
        fileName:
          type:
            - string
            - 'null'
          description: Original name of the file uploaded or downloaded.
        email:
          type:
            - string
            - 'null'
          format: email
          description: >-
            Email of the user who uploaded or created the document. If uploaded
            programmatically, this will be the email associated with the API
            key. Email will show admin@nectarclimate.com if document was scraped
            by Nectar.
        jobId:
          type:
            - string
            - 'null'
          description: The ID of the job that processed the document.
        billDate:
          type: string
          format: date
          description: Date of the bill.
        notes:
          type:
            - string
            - 'null'
          description: Additional notes related to the document.
        dueDate:
          type:
            - string
            - 'null'
          format: date
          description: Due date from the bill.
        totalCharges:
          type: string
          format: decimal
          pattern: ^-?\d{0,18}(?:\.\d{0,2})?$
          description: >-
            The total charges from the current bill including any overdue
            charges and penalties. This is often also known as the current
            closing balance = total due.
        chargesUnits:
          allOf:
            - $ref: '#/components/schemas/ChargesUnitsEnum'
          description: |-
            Currency unit for the charges and balances.

            * `USD` - Usd
            * `EUR` - Eur
            * `AED` - Aed
            * `AFN` - Afn
            * `ALL` - All
            * `AMD` - Amd
            * `ANG` - Ang
            * `AOA` - Aoa
            * `ARS` - Ars
            * `AUD` - Aud
            * `AWG` - Awg
            * `AZN` - Azn
            * `BAM` - Bam
            * `BBD` - Bbd
            * `BDT` - Bdt
            * `BGN` - Bgn
            * `BHD` - Bhd
            * `BIF` - Bif
            * `BMD` - Bmd
            * `BND` - Bnd
            * `BOB` - Bob
            * `BOV` - Bov
            * `BRL` - Brl
            * `BSD` - Bsd
            * `BTN` - Btn
            * `BWP` - Bwp
            * `BYN` - Byn
            * `BZD` - Bzd
            * `CAD` - Cad
            * `CDF` - Cdf
            * `CHE` - Che
            * `CHF` - Chf
            * `CHW` - Chw
            * `CLF` - Clf
            * `CLP` - Clp
            * `CNY` - Cny
            * `COP` - Cop
            * `COU` - Cou
            * `CRC` - Crc
            * `CUC` - Cuc
            * `CUP` - Cup
            * `CVE` - Cve
            * `CZK` - Czk
            * `DJF` - Djf
            * `DKK` - Dkk
            * `DOP` - Dop
            * `DZD` - Dzd
            * `EGP` - Egp
            * `ERN` - Ern
            * `ETB` - Etb
            * `FJD` - Fjd
            * `FKP` - Fkp
            * `GBP` - Gbp
            * `GEL` - Gel
            * `GHS` - Ghs
            * `GIP` - Gip
            * `GMD` - Gmd
            * `GNF` - Gnf
            * `GTQ` - Gtq
            * `GYD` - Gyd
            * `HKD` - Hkd
            * `HNL` - Hnl
            * `HRK` - Hrk
            * `HTG` - Htg
            * `HUF` - Huf
            * `IDR` - Idr
            * `ILS` - Ils
            * `INR` - Inr
            * `IQD` - Iqd
            * `IRR` - Irr
            * `ISK` - Isk
            * `JMD` - Jmd
            * `JOD` - Jod
            * `JPY` - Jpy
            * `KES` - Kes
            * `KGS` - Kgs
            * `KHR` - Khr
            * `KMF` - Kmf
            * `KPW` - Kpw
            * `KRW` - Krw
            * `KWD` - Kwd
            * `KYD` - Kyd
            * `KZT` - Kzt
            * `LAK` - Lak
            * `LBP` - Lbp
            * `LKR` - Lkr
            * `LRD` - Lrd
            * `LSL` - Lsl
            * `LYD` - Lyd
            * `MAD` - Mad
            * `MDL` - Mdl
            * `MGA` - Mga
            * `MKD` - Mkd
            * `MMK` - Mmk
            * `MNT` - Mnt
            * `MOP` - Mop
            * `MRU` - Mru
            * `MUR` - Mur
            * `MVR` - Mvr
            * `MWK` - Mwk
            * `MXN` - Mxn
            * `MXV` - Mxv
            * `MYR` - Myr
            * `MZN` - Mzn
            * `NAD` - Nad
            * `NGN` - Ngn
            * `NIO` - Nio
            * `NOK` - Nok
            * `NPR` - Npr
            * `NZD` - Nzd
            * `OMR` - Omr
            * `PAB` - Pab
            * `PEN` - Pen
            * `PGK` - Pgk
            * `PHP` - Php
            * `PKR` - Pkr
            * `PLN` - Pln
            * `PYG` - Pyg
            * `QAR` - Qar
            * `RON` - Ron
            * `RSD` - Rsd
            * `RUB` - Rub
            * `RWF` - Rwf
            * `SAR` - Sar
            * `SBD` - Sbd
            * `SCR` - Scr
            * `SDG` - Sdg
            * `SEK` - Sek
            * `SGD` - Sgd
            * `SHP` - Shp
            * `SLE` - Sle
            * `SLL` - Sll
            * `SOS` - Sos
            * `SRD` - Srd
            * `SSP` - Ssp
            * `STN` - Stn
            * `SVC` - Svc
            * `SYP` - Syp
            * `SZL` - Szl
            * `THB` - Thb
            * `TJS` - Tjs
            * `TMT` - Tmt
            * `TND` - Tnd
            * `TOP` - Top
            * `TRY` - Try
            * `TTD` - Ttd
            * `TWD` - Twd
            * `TZS` - Tzs
            * `UAH` - Uah
            * `UGX` - Ugx
            * `USN` - Usn
            * `UYI` - Uyi
            * `UYU` - Uyu
            * `UZS` - Uzs
            * `VED` - Ved
            * `VEF` - Vef
            * `VND` - Vnd
            * `VUV` - Vuv
            * `WST` - Wst
            * `XAF` - Xaf
            * `XCD` - Xcd
            * `XOF` - Xof
            * `XPF` - Xpf
            * `XSU` - Xsu
            * `YER` - Yer
            * `ZAR` - Zar
            * `ZMW` - Zmw
            * `ZWL` - Zwl
        utilityCompany:
          type:
            - string
            - 'null'
          description: Name of the utility company providing the service.
        status:
          type:
            - string
            - 'null'
          description: Custom status name assigned to the document by the company, if set.
        sourceType:
          allOf:
            - $ref: '#/components/schemas/SourceTypeEnum'
          description: >-
            Source of the data for this workflow result. Defaults to INVOICE for
            a regularly billed invoice. Can also be more granular SMART_METER
            data or MANUAL for manually entered data.


            * `INVOICE` - Invoice

            * `SMART_METER` - Smart Meter

            * `MANUAL` - Manual
        isFlagged:
          type: boolean
          description: >-
            User-managed bookmark for tracking bills. Flagging a bill is for
            personal organization only — it does not create a data quality issue
            or affect whether the bill is included in exports.
        flaggedStatus:
          type:
            - string
            - 'null'
          description: >-
            DEPRECATED: Kept for backwards compatibility only. Will be removed
            in a future API version.
        revisedDocumentId:
          type:
            - string
            - 'null'
          description: ID of the document that revises this one.
        connectionId:
          type:
            - string
            - 'null'
          description: >-
            ID of the utility account connection that generated this document.
            Null for manually uploaded documents.
      required:
        - auditTrailUrl
        - billDate
        - chargesUnits
        - connectionId
        - created
        - flaggedStatus
        - id
        - revisedDocumentId
        - status
        - url
        - utilityCompany
    ElectricityUsageUnitsEnum:
      enum:
        - Wh
        - kWh
        - MWh
        - GWh
      type: string
      description: |-
        * `Wh` - WH
        * `kWh` - KWH
        * `MWh` - MWH
        * `GWh` - GWH
    ChargesUnitsEnum:
      enum:
        - USD
        - EUR
        - AED
        - AFN
        - ALL
        - AMD
        - ANG
        - AOA
        - ARS
        - AUD
        - AWG
        - AZN
        - BAM
        - BBD
        - BDT
        - BGN
        - BHD
        - BIF
        - BMD
        - BND
        - BOB
        - BOV
        - BRL
        - BSD
        - BTN
        - BWP
        - BYN
        - BZD
        - CAD
        - CDF
        - CHE
        - CHF
        - CHW
        - CLF
        - CLP
        - CNY
        - COP
        - COU
        - CRC
        - CUC
        - CUP
        - CVE
        - CZK
        - DJF
        - DKK
        - DOP
        - DZD
        - EGP
        - ERN
        - ETB
        - FJD
        - FKP
        - GBP
        - GEL
        - GHS
        - GIP
        - GMD
        - GNF
        - GTQ
        - GYD
        - HKD
        - HNL
        - HRK
        - HTG
        - HUF
        - IDR
        - ILS
        - INR
        - IQD
        - IRR
        - ISK
        - JMD
        - JOD
        - JPY
        - KES
        - KGS
        - KHR
        - KMF
        - KPW
        - KRW
        - KWD
        - KYD
        - KZT
        - LAK
        - LBP
        - LKR
        - LRD
        - LSL
        - LYD
        - MAD
        - MDL
        - MGA
        - MKD
        - MMK
        - MNT
        - MOP
        - MRU
        - MUR
        - MVR
        - MWK
        - MXN
        - MXV
        - MYR
        - MZN
        - NAD
        - NGN
        - NIO
        - NOK
        - NPR
        - NZD
        - OMR
        - PAB
        - PEN
        - PGK
        - PHP
        - PKR
        - PLN
        - PYG
        - QAR
        - RON
        - RSD
        - RUB
        - RWF
        - SAR
        - SBD
        - SCR
        - SDG
        - SEK
        - SGD
        - SHP
        - SLE
        - SLL
        - SOS
        - SRD
        - SSP
        - STN
        - SVC
        - SYP
        - SZL
        - THB
        - TJS
        - TMT
        - TND
        - TOP
        - TRY
        - TTD
        - TWD
        - TZS
        - UAH
        - UGX
        - USN
        - UYI
        - UYU
        - UZS
        - VED
        - VEF
        - VND
        - VUV
        - WST
        - XAF
        - XCD
        - XOF
        - XPF
        - XSU
        - YER
        - ZAR
        - ZMW
        - ZWL
      type: string
      description: |-
        * `USD` - Usd
        * `EUR` - Eur
        * `AED` - Aed
        * `AFN` - Afn
        * `ALL` - All
        * `AMD` - Amd
        * `ANG` - Ang
        * `AOA` - Aoa
        * `ARS` - Ars
        * `AUD` - Aud
        * `AWG` - Awg
        * `AZN` - Azn
        * `BAM` - Bam
        * `BBD` - Bbd
        * `BDT` - Bdt
        * `BGN` - Bgn
        * `BHD` - Bhd
        * `BIF` - Bif
        * `BMD` - Bmd
        * `BND` - Bnd
        * `BOB` - Bob
        * `BOV` - Bov
        * `BRL` - Brl
        * `BSD` - Bsd
        * `BTN` - Btn
        * `BWP` - Bwp
        * `BYN` - Byn
        * `BZD` - Bzd
        * `CAD` - Cad
        * `CDF` - Cdf
        * `CHE` - Che
        * `CHF` - Chf
        * `CHW` - Chw
        * `CLF` - Clf
        * `CLP` - Clp
        * `CNY` - Cny
        * `COP` - Cop
        * `COU` - Cou
        * `CRC` - Crc
        * `CUC` - Cuc
        * `CUP` - Cup
        * `CVE` - Cve
        * `CZK` - Czk
        * `DJF` - Djf
        * `DKK` - Dkk
        * `DOP` - Dop
        * `DZD` - Dzd
        * `EGP` - Egp
        * `ERN` - Ern
        * `ETB` - Etb
        * `FJD` - Fjd
        * `FKP` - Fkp
        * `GBP` - Gbp
        * `GEL` - Gel
        * `GHS` - Ghs
        * `GIP` - Gip
        * `GMD` - Gmd
        * `GNF` - Gnf
        * `GTQ` - Gtq
        * `GYD` - Gyd
        * `HKD` - Hkd
        * `HNL` - Hnl
        * `HRK` - Hrk
        * `HTG` - Htg
        * `HUF` - Huf
        * `IDR` - Idr
        * `ILS` - Ils
        * `INR` - Inr
        * `IQD` - Iqd
        * `IRR` - Irr
        * `ISK` - Isk
        * `JMD` - Jmd
        * `JOD` - Jod
        * `JPY` - Jpy
        * `KES` - Kes
        * `KGS` - Kgs
        * `KHR` - Khr
        * `KMF` - Kmf
        * `KPW` - Kpw
        * `KRW` - Krw
        * `KWD` - Kwd
        * `KYD` - Kyd
        * `KZT` - Kzt
        * `LAK` - Lak
        * `LBP` - Lbp
        * `LKR` - Lkr
        * `LRD` - Lrd
        * `LSL` - Lsl
        * `LYD` - Lyd
        * `MAD` - Mad
        * `MDL` - Mdl
        * `MGA` - Mga
        * `MKD` - Mkd
        * `MMK` - Mmk
        * `MNT` - Mnt
        * `MOP` - Mop
        * `MRU` - Mru
        * `MUR` - Mur
        * `MVR` - Mvr
        * `MWK` - Mwk
        * `MXN` - Mxn
        * `MXV` - Mxv
        * `MYR` - Myr
        * `MZN` - Mzn
        * `NAD` - Nad
        * `NGN` - Ngn
        * `NIO` - Nio
        * `NOK` - Nok
        * `NPR` - Npr
        * `NZD` - Nzd
        * `OMR` - Omr
        * `PAB` - Pab
        * `PEN` - Pen
        * `PGK` - Pgk
        * `PHP` - Php
        * `PKR` - Pkr
        * `PLN` - Pln
        * `PYG` - Pyg
        * `QAR` - Qar
        * `RON` - Ron
        * `RSD` - Rsd
        * `RUB` - Rub
        * `RWF` - Rwf
        * `SAR` - Sar
        * `SBD` - Sbd
        * `SCR` - Scr
        * `SDG` - Sdg
        * `SEK` - Sek
        * `SGD` - Sgd
        * `SHP` - Shp
        * `SLE` - Sle
        * `SLL` - Sll
        * `SOS` - Sos
        * `SRD` - Srd
        * `SSP` - Ssp
        * `STN` - Stn
        * `SVC` - Svc
        * `SYP` - Syp
        * `SZL` - Szl
        * `THB` - Thb
        * `TJS` - Tjs
        * `TMT` - Tmt
        * `TND` - Tnd
        * `TOP` - Top
        * `TRY` - Try
        * `TTD` - Ttd
        * `TWD` - Twd
        * `TZS` - Tzs
        * `UAH` - Uah
        * `UGX` - Ugx
        * `USN` - Usn
        * `UYI` - Uyi
        * `UYU` - Uyu
        * `UZS` - Uzs
        * `VED` - Ved
        * `VEF` - Vef
        * `VND` - Vnd
        * `VUV` - Vuv
        * `WST` - Wst
        * `XAF` - Xaf
        * `XCD` - Xcd
        * `XOF` - Xof
        * `XPF` - Xpf
        * `XSU` - Xsu
        * `YER` - Yer
        * `ZAR` - Zar
        * `ZMW` - Zmw
        * `ZWL` - Zwl
    SourceTypeEnum:
      enum:
        - INVOICE
        - SMART_METER
        - MANUAL
      type: string
      description: |-
        * `INVOICE` - Invoice
        * `SMART_METER` - Smart Meter
        * `MANUAL` - Manual
  securitySchemes:
    ExternalAuthentication:
      type: apiKey
      in: header
      name: X-API-KEY

````